#!/bin/bash
name=$1
gwtype=$2
mount /data

if [ -e /data/apps ]; then
    chown -R dtnuser:dtnuser /data/apps
    cd /data/apps
    rm -rf /data/apps/*
    echo "cloning DTN2 (N4C)"
    sudo -u dtnuser /usr/bin/hg clone -r 3509 http://134.226.36.138/code/dtnrg/DTN2
    echo "patching DTN2 with N4C patch"
    sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/n4c/N4C-DTN2-patches
    cd DTN2
    sudo -u dtnuser /usr/bin/hg import ../N4C-DTN2-patches/n4c-dtn2-patch-1
    cd ..
    echo "cloning oasys"
    sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/dtnrg/oasys


    echo "cloning LTPlib"
    sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/n4c/LTPlib
    wget http://134.226.36.138/binary/pub/boutell/cgic205.tar
#    wget http://www.boutell.com/cgic/cgic205.tar.gz
    echo "cloning test-utils"
    sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/n4c/test-utils

    if [ "$name" == "n4crouter" ]; then
	echo "cloning DTNmailex"
	sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/n4c/DTNmailex

	echo "cloning pbm"
	sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/n4c/pbm

	echo "getting Phidgetlinux_2.1.6.20100428.tar.gz with wget"
#	wget http://www.phidgets.com/downloads/libraries/Phidgetlinux_2.1.6.20100428.tar.gz
	wget http://134.226.36.138/binary/pub/phidgets/Phidgetlinux_2.1.6.20100428.tar.gz

	echo "cloning HTMLrequester"
	chown www-data:www-data /data/www/private
	cd /data/www/private
	sudo -u www-data /usr/bin/hg clone http://134.226.36.138/code/n4c/HTMLrequester

	echo "cloning N4Cbuild"
	cd /data/apps
	sudo -u dtnuser /usr/bin/hg clone https://134.226.36.138/code/n4c/N4Cbuild

	echo "cloning statichtml"
	cd /data/www
	sudo -u www-data /usr/bin/hg clone http://134.226.36.138/code/n4c/statichtml

    elif [ "$name" == "n4cgateway" ]; then
        echo "cloning pbm"
        sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/n4c/pbm
        echo "getting Phidgetlinux_2.1.6.20100428.tar.gz with wget"
        wget http://134.226.36.138/binary/pub/phidgets/Phidgetlinux_2.1.6.20100428.tar.gz
        echo "cloning N4Cbuild"
        cd /data/apps
        sudo -u dtnuser /usr/bin/hg clone https://134.226.36.138/code/n4c/N4Cbuild

	if [ "$gwtype" == "gateway-basic" ]; then
	    echo "finished cloning software for $gwtype"
	elif [ "$gwtype" == "gateway-router" ]; then
	    echo "cloning DTNmailex"
	    sudo -u dtnuser /usr/bin/hg clone http://134.226.36.138/code/n4c/DTNmailex

	    echo "cloning HTMLrequester"
	    chown www-data:www-data /data/www/private
	    cd /data/www/private
	    sudo -u www-data /usr/bin/hg clone http://134.226.36.138/code/n4c/HTMLrequester

	    echo "cloning N4Cbuild"
	    cd /data/apps
	    sudo -u dtnuser /usr/bin/hg clone https://134.226.36.138/code/n4c/N4Cbuild

	    echo "cloning statichtml"
	    cd /data/www
	    sudo -u www-data /usr/bin/hg clone http://134.226.36.138/code/n4c/statichtml

	fi
    fi
cd /
else
echo "/data/apps does not exist"
fi
