#!/bin/bash
disk=$1
part=$2
name=$3
gwtype=$4
platform=$5
cd /
if [ -e $disk$part ]; then
echo "$disk$part partition exists"
if [ -e /data ]; then
echo "deleting /data as it exists"
rm -rf /data
echo "creating /data"
mkdir /data
else
echo "creating /data"
mkdir /data
fi
else
echo "No partition $disk$part"
exit 1
fi

if [ -e $disk$part ]; then
    echo "mounting /data $disk$part"
    mount /data
else
    echo "proceeding without mount /data"
fi
    echo "creating directory structure"
if [ "$name" == "n4cmule" ]; then
    if [ "$platform" == "WRAP" ]; then
	rm -rf /data/*
	mkdir /data/dtn /data/apps /data/dtn/certs /data/dtn/conf /data/dtn/log /data/dtn/scripts /data/dtn/storage /data/dtn/payload /var/log/dtn /lib/tcl8.4 /home
	rm -r /etc/rc.d/S60monit
    elif [ "$platform" == "eeepc" ]; then
        rm -rf /data/*
        mkdir /data/dtn /data/apps /data/dtn/certs /data/dtn/conf /data/dtn/log /data/dtn/scripts /data/dtn/storage /data/dtn/payload /var/log/dtn
        chown -R dtnuser:dtnuser /data /var/log/dtn
    fi
elif [ "$name" == "n4crouter" ]; then
    rm -rf /data/*
    mkdir -p /data/dtn /data/apps /data/www /data/www/skool /data/www/skool/swedish /data/www/skool/english /data/dtn/cache /data/dtn/certs /data/dtn/conf /data/dtn/log /data/dtn/mail /data/dtn/dtnmailex /data/dtn/dtnmailex/todtn /data/dtn/dtnmailex/fromdtn /data/dtn/dtnmailex/todtn/delivery /data/dtn/scripts /data/dtn/storage /data/dtn/payload /data/www/private /data/www/public /var/log/dtn /data/dtn/mailaccounts/ /data/dtn/mailaccounts/exceptions /data/dtn/mailaccounts/processed
    useradd --uid 5000 --comment "dtnmailuser" mailowner
    chown -R dtnuser:dtnuser /data /var/log/dtn
    chown -R www-data:www-data /data/www
    chown -R www-data:www-data /data/dtn/mailaccounts 
    chown -R mailowner:mailowner /data/dtn/mail
    chown -R dtnuser:dtnuser /data/dtn/dtnmailex
    chown -R proxy:proxy /data/dtn/cache
elif [ "$name" == "n4cgateway" ]; then
    if [ "$gwtype" == "gateway-router" ]; then
	rm -rf /data/*
	mkdir -p /data/dtn /data/apps /data/www /data/www/skool /data/www/skool/swedish /data/www/skool/english /data/dtn/cache /data/dtn/certs /data/dtn/conf /data/dtn/log /data/dtn/mail /data/dtn/dtnmailex /data/dtn/dtnmailex/todtn /data/dtn/dtnmailex/fromdtn /data/dtn/dtnmailex/todtn/delivery /data/dtn/scripts /data/dtn/storage /data/dtn/payload /data/www/private /data/www/public /var/log/dtn /data/dtn/mailaccounts/ /data/dtn/mailaccounts/exceptions /data/dtn/mailaccounts/processed
	useradd --uid 5000 --comment "dtnmailuser" mailowner
	chown -R dtnuser:dtnuser /data /var/log/dtn
	chown -R www-data:www-data /data/www
	chown -R www-data:www-data /data/dtn/mailaccounts
	chown -R mailowner:mailowner /data/dtn/mail
	chown -R dtnuser:dtnuser /data/dtn/dtnmailex
	chown -R proxy:proxy /data/dtn/cache
    else
	rm -rf /data/*
	mkdir /data/dtn /data/apps /data/dtn/certs /data/dtn/conf /data/dtn/log /data/dtn/scripts /data/dtn/storage /data/dtn/payload /var/log/dtn 
	chown -R dtnuser:dtnuser /data /var/log/dtn
    fi
fi
echo "finished creating directory structure"
