#!/bin/bash

## N4C router build script
## Alex McMahon 05/04/2010


bdir=`pwd`
disk="NULL"
part="NULL"
gwtype="NULL"
clear
echo ""

echo -n "Please provide password for keys and certs and press [ENTER]: "
read password
if [ "$password" == "" ]; then
    exit 0
    echo "this won't work"
else
    echo "once openssl is built this password will decrypt and decompress $bdir/enc"
fi

hostname=`hostname`
name=`echo $hostname | awk -F "-" '{print $1}'`
no=`echo $hostname | awk -F "-" '{print $1}'`

echo "hostname is $name-$no"
echo "Unique EID is $name-$no.dtn"

if [ "$name" == "n4crouter" ]; then
PS3="Choose (1-2):"
echo "Choose a platform from the list below."
select platform in proteus eeepc 
do

        if [ "$platform" == "proteus" ]; then
	    if [ -e /dev/mmcblk0 ]; then
		disk="/dev/mmcblk0"
		part="p1"
	    else 
		echo "the disk does not exist... exiting"
	    exit 1
	    fi
	elif [ "$platform" == "eeepc" ]; then
	    if [ -e /dev/sdb ]; then
		disk="/dev/sdb"
		part="1"
            else
                echo "the disk doe not exist... exiting"
#            exit 1
            fi
	elif [ "$no" = "" ]; then
	echo "Error in entry, please run script again."
        exit 1
        fi
        break
done

elif [ "$name" == "n4cgateway" ]; then
PS3="Choose (1-2):"
echo "Choose a gateway type from the list below."
select gwtype in gateway-basic gateway-router
do

        if [ "$gwtype" == "gateway-basic" ]; then
	    echo "you have selected $gwtype which will install a basic gateway"
	elif [ "$gwtype" == "gateway-router" ]; then
	    echo "you have selected $gwtype which will install a gateway router"
	else
	    echo "that is an incorrect selection"
	exit 1
	fi
        break
done

PS3="Choose (1-2):"
echo "Choose a platform from the list below."
select platform in proteus eeepc
do

        if [ "$platform" == "proteus" ]; then
            if [ -e /dev/mmcblk0 ]; then
                disk="/dev/mmcblk0"
                part="p1"
            else
                echo "the disk does not exist... exiting"
            exit 1
            fi
        elif [ "$platform" == "eeepc" ]; then
            if [ -e /dev/sdb ]; then
                disk="/dev/sdb"
                part="1"
            else
                echo "the disk does not exist... exiting"
            exit 1
            fi
        elif [ "$no" = "" ]; then
        echo "Error in entry...exiting."
        exit 1
        fi
        break
done

elif [ "$name" == "n4cmule" ]; then
PS3="Choose (1-3):"
echo "Choose a platform from the list below."
select platform in proteus eeepc WRAP
do

        if [ "$platform" == "proteus" ]; then
            if [ -e /dev/mmcblk0 ]; then
                disk="/dev/mmcblk0"
                part="p1"
            else
                echo "$disk does not exist, exiting"
            exit 1
            fi
        elif [ "$platform" == "eeepc" ]; then
            if [ -e /dev/sdb ]; then
                disk="/dev/sdb"
                part="1"
            else
                echo "$disk does not exist, exiting"
            exit 1
            fi
        elif [ "$platform" == "WRAP" ]; then
                disk="/dev/sda"
                part="3"
        elif [ "$no" = "" ]; then
        echo "Error in entry, please run script again."
        exit 1
        fi
        break
done
fi

echo "generate configuration files" 
./patch_configs.sh $disk $part $name $platform $gwtype $no $password
