#!/usr/bin/tclsh
#
set filename "topology.tcl"
source $filename
#
# Common config for all nodes
#
# generate the config
if {$type == "n4crouter"} {
    puts "\$ttl 3840"
    puts "[lindex [split $subnet .] 2].[lindex [split $subnet .] 1].[lindex [split $subnet .] 0].in-addr.arpa. IN      SOA     $localhost.$domain. $email ("
    puts "                    [clock seconds]"
    puts "                    10800"
    puts "                    3600"
    puts "                    604800"
    puts "                    38400 )"
    puts "[lindex [split $subnet .] 2].[lindex [split $subnet .] 1].[lindex [split $subnet .] 0].in-addr.arpa.	IN	NS	$localhost.$domain."
    puts "[lindex [split $addr(n4cgateway-1) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cgateway-1.$domain."
    puts "[lindex [split $addr(n4cgateway-2) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cgateway-2.$domain."
    puts "[lindex [split $addr(n4crouter-1) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-1.$domain."
    puts "[lindex [split $addr(n4crouter-2) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-2.$domain."
    puts "[lindex [split $addr(n4crouter-3) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-3.$domain."
    puts "[lindex [split $addr(n4crouter-4) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-4.$domain."
    puts "[lindex [split $addr(n4crouter-5) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-5.$domain."
    puts "[lindex [split $addr(n4cmule-1) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-1.$domain."
    puts "[lindex [split $addr(n4cmule-2) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-2.$domain."
    puts "[lindex [split $addr(n4cmule-3) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-3.$domain."
    puts "[lindex [split $addr(n4cmule-4) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-4.$domain."
    puts "[lindex [split $addr(n4cmule-5) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-5.$domain."

    puts "0.[lindex [split $subnet .] 2].[lindex [split $subnet .] 1].[lindex [split $subnet .] 0].in-addr.arpa.	IN	PTR	village.n4c.eu."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     proxy.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     pop.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     www.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     imap.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     ntp.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     smtp.$domain."
    } elseif {$type == "n4cgateway"} {
    puts "\$ttl 3840"
    puts "[lindex [split $addr(n4cgateway-1) .] 0].in-addr.arpa. IN      SOA     $localhost.$domain. $email ("
    puts "                    [clock seconds]"
    puts "                    10800"
    puts "                    3600"
    puts "                    604800"
    puts "                    38400 )"
    puts "[lindex [split $addr(n4cgateway-1) .] 0].in-addr.arpa.        IN      NS      $localhost.$domain."
    puts "[lindex [split $addr(n4cgateway-1) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cgateway-1.$domain."
    puts "[lindex [split $addr(n4cgateway-2) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cgateway-2.$domain."
    puts "[lindex [split $addr(n4crouter-1) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-1.$domain."
    puts "[lindex [split $addr(n4crouter-2) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-2.$domain."
    puts "[lindex [split $addr(n4crouter-3) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-3.$domain."
    puts "[lindex [split $addr(n4crouter-4) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-4.$domain."
    puts "[lindex [split $addr(n4crouter-5) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4crouter-5.$domain."
    puts "[lindex [split $addr(n4cmule-1) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-1.$domain."
    puts "[lindex [split $addr(n4cmule-2) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-2.$domain."
    puts "[lindex [split $addr(n4cmule-3) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-3.$domain."
    puts "[lindex [split $addr(n4cmule-4) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-4.$domain."
    puts "[lindex [split $addr(n4cmule-5) .] 3].14.125.10.in-addr.arpa.  IN      PTR     n4cmule-5.$domain."
    puts "0.0.125.10.in-addr.arpa.      IN      PTR     village.n4c.eu."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     proxy.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     pop.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     www.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     imap.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     ntp.$domain."
    puts "[lindex [split $addr($localhost) .] 3].14.125.10.in-addr.arpa.  IN      PTR     smtp.$domain."
    } elseif {$type == "n4cmule"} {
        if {$id == "WRAP"} {
        } else {
        }
}

