#!/usr/bin/tclsh
#
set COMMON_CONFIG \
{
DATE=`date -u +%d%m%y-%H%M%S`
HOSTNAME=`hostname`
LOCATION=/tmp
LOG=$HOSTNAME-$DATE.log
LIST=/tmp/bundle_list
IFACE=wlan0
echo "log $LOCATION/$LOG for node $HOSTNAME generated on $DATE"
echo "log $LOCATION/$LOG for node $HOSTNAME generated on $DATE">$LOCATION/$LOG
#dtnd-control bundle_list | egrep -v All|awk -F ":" '{print $1}'>$LIST 
echo "##########################################">>$LOCATION/$LOG
echo "##        Bundle stats">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
dtnd-control bundle_list>>$LOCATION/$LOG
#echo "##########################################">>$LOCATION/$LOG
#echo "##        Bundle info">>$LOCATION/$LOG
#echo "##########################################">>$LOCATION/$LOG
#for bundle in `cat /tmp/bundle_list`; do dtnd-control -port 5050 -id $bundle bundle_info>>$LOCATION/$LOG; done
echo "##########################################">>$LOCATION/$LOG
echo "##        Route dump">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
dtnd-control route_dump>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        Registration list">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
dtnd-control registration_list>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        Daemon stats">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
dtnd-control daemon_stats>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        Network">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
ifconfig -a>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
arp>>$LOCATION/$LOG
if [ -e /usr/sbin/iw ]; then
echo "##########################################">>$LOCATION/$LOG
iw dev $IFACE station dump>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
iw dev $IFACE mpath dump>>$LOCATION/$LOG
fi
echo "##########################################">>$LOCATION/$LOG
netstat -nt>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        Processes">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
ps -ef>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        Disk ">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
df -h>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        uptime ">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
uptime>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        lastlog ">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
lastlog -b1>>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
echo "##        DTN2 S10 logs">>$LOCATION/$LOG
echo "##########################################">>$LOCATION/$LOG
find /data/dtn/log/dtnd* /var/log/dtn/dtnd* -mtime -1  -exec cat {} \;|grep S10>>$LOCATION/$LOG
echo "`date` creating $LOCATION/$LOG.tzf"
tar cvfz $LOCATION/$LOG.tzf $LOCATION/$LOG 
echo "`date` removing $LOCATION/$LOG"
rm $LOCATION/$LOG
echo "`date` sending $LOCATION/$LOG.tzf"
/usr/local/bin/sendlog.php $LOCATION $LOG.tzf
echo "`date` removing $LOCATION/$LOG.tzf"
rm $LOCATION/$LOG.tzf
echo "`date` Finished"
}
# generate the config
puts "#!/bin/bash"
puts $COMMON_CONFIG
