#!/usr/bin/tclsh
#
# Simple tcl script to generate a static topology of dtn links and
# routes for a network.
set addr(basil.dsg.cs.tcd.ie)   192.168.1.102
set addr(n4cgateway-1)          10.125.14.10
set addr(n4cgateway-2)          10.125.14.11
set addr(n4crouter-1)           10.125.14.12
set addr(n4crouter-2)           10.125.14.13
set addr(n4crouter-3)           10.125.14.14
set addr(n4crouter-4)           10.125.14.15
set addr(n4crouter-5)           10.125.14.16
set addr(n4cmule-1)             10.125.14.17
set addr(n4cmule-2)             10.125.14.18
set addr(n4cmule-3)             10.125.14.19
set addr(n4cmule-4)             10.125.14.20
set addr(n4cmule-5)             10.125.14.21



set platform [lindex $argv 0]
set localhost [lindex [split [info hostname] .] 0]
set ip $addr([lindex [split [info hostname] .] 0])
set type [lindex [split [info hostname] -] 0]
set net [lindex [split $ip .] 2]
set no [lindex [split $ip .] 3]
set rowip "10.125.[expr "$net" + "1" ].$no"

# generate the config
if {$type == "n4crouter"} {
puts "*mangle"
puts ":PREROUTING ACCEPT \[1816:154200\]"
puts ":INPUT ACCEPT \[1814:154064\]"
puts ":FORWARD ACCEPT \[0:0\]"
puts ":OUTPUT ACCEPT \[1828:234194\]"
puts ":POSTROUTING ACCEPT \[1828:234194\]"
puts "COMMIT"
puts "*nat"
puts ":PREROUTING ACCEPT \[31:3167\]"
puts ":POSTROUTING ACCEPT \[164:10850\]"
puts ":OUTPUT ACCEPT \[164:10850\]"
puts "COMMIT"
puts "*filter"
puts ":INPUT ACCEPT \[78:5784\]"
puts ":FORWARD ACCEPT \[0:0\]"
puts ":OUTPUT ACCEPT \[1350:205278\]"
puts "-A INPUT -i lo -j ACCEPT"
puts "-A INPUT -p icmp -m icmp --icmp-type 8 -j ACCEPT"
puts "-A INPUT -p icmp -m icmp --icmp-type 0 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 53 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 53 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 123 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 123 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 22 -j ACCEPT"
puts "-A INPUT -d 10.125.[expr "$net" + "2" ].$no -p tcp -m tcp --dport 22 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 25 -j ACCEPT"
puts "-A INPUT -p tcp -m tcp --dport 80 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 143 -j ACCEPT"
puts "-A INPUT -p tcp -m tcp --dport 443 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 465 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 4556 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 4556 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 1113 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 1113 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 1194 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 1194 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 2812 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 9556 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 9556 -j ACCEPT"
puts "-A INPUT -m state --state RELATED,ESTABLISHED -j ACCEPT"
puts "-A INPUT -j DROP" 
puts "-A OUTPUT -p icmp -m icmp --icmp-type 0 -j ACCEPT" 
puts "-A OUTPUT -p icmp -m icmp --icmp-type 8 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 53 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 53 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 123 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 123 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 143 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 22 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 25 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 80 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 443 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 465 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 4556 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 4556 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 1113 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 1113 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 1194 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 1194 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 2812 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 9556 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 9556 -j ACCEPT" 
puts "COMMIT"

    } elseif {$type == "n4cgateway"} {
	if {$localhost == "n4cgateway-1"} {
	    set openvpn 192.168.1.152
	} elseif {$localhost == "n4cgateway-2"} {
	    set openvpn 192.168.1.153
	}
puts "*mangle"
puts ":PREROUTING ACCEPT \[1816:154200\]"
puts ":INPUT ACCEPT \[1814:154064\]"
puts ":FORWARD ACCEPT \[0:0\]"
puts ":OUTPUT ACCEPT \[1828:234194\]"
puts ":POSTROUTING ACCEPT \[1828:234194\]"
puts "COMMIT"
puts "*nat"
puts ":PREROUTING ACCEPT \[31:3167\]"
puts ":POSTROUTING ACCEPT \[164:10850\]"
puts ":OUTPUT ACCEPT \[164:10850\]"
puts "COMMIT"
puts "*filter"
puts ":INPUT ACCEPT \[78:5784\]"
puts ":FORWARD ACCEPT \[0:0\]"
puts ":OUTPUT ACCEPT \[1350:205278\]"
puts "-A INPUT -i lo -j ACCEPT"
puts "-A INPUT -p icmp -m icmp --icmp-type 8 -j ACCEPT"
puts "-A INPUT -p icmp -m icmp --icmp-type 0 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 53 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 53 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 123 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 123 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 22 -j ACCEPT"
puts "-A INPUT -d 10.125.[expr "$net" + "2" ].$no -p tcp -m tcp --dport 22 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 25 -j ACCEPT"
puts "-A INPUT -p tcp -m tcp --dport 80 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 143 -j ACCEPT"
puts "-A INPUT -p tcp -m tcp --dport 443 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 465 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 4556 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 4556 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 1113 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 1113 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 1194 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 1194 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 2812 -j ACCEPT"
puts "-A INPUT -d $ip -p udp -m udp --dport 9556 -j ACCEPT"
puts "-A INPUT -d $ip -p tcp -m tcp --dport 9556 -j ACCEPT"
puts "-A INPUT -d $openvpn -p udp -m udp --dport 53 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 53 -j ACCEPT"
puts "-A INPUT -d $openvpn -p udp -m udp --dport 123 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 123 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 22 -j ACCEPT"
puts "-A INPUT -d 10.125.[expr "$net" + "2" ].$no -p tcp -m tcp --dport 22 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 25 -j ACCEPT"
puts "-A INPUT -p tcp -m tcp --dport 80 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 143 -j ACCEPT"
puts "-A INPUT -p tcp -m tcp --dport 443 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 465 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 4556 -j ACCEPT"
puts "-A INPUT -d $openvpn -p udp -m udp --dport 4556 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 1113 -j ACCEPT"
puts "-A INPUT -d $openvpn -p udp -m udp --dport 1113 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 1194 -j ACCEPT"
puts "-A INPUT -d $openvpn -p udp -m udp --dport 1194 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 2812 -j ACCEPT"
puts "-A INPUT -d $openvpn -p udp -m udp --dport 9556 -j ACCEPT"
puts "-A INPUT -d $openvpn -p tcp -m tcp --dport 9556 -j ACCEPT"
puts "-A INPUT -m state --state RELATED,ESTABLISHED -j ACCEPT"
puts "-A INPUT -j DROP" 
puts "-A OUTPUT -p icmp -m icmp --icmp-type 0 -j ACCEPT" 
puts "-A OUTPUT -p icmp -m icmp --icmp-type 8 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 53 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 53 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 123 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 123 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 143 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 22 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 25 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 80 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 443 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 465 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 4556 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 4556 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 1113 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 1113 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 1194 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 1194 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 2812 -j ACCEPT" 
puts "-A OUTPUT -p udp -m udp --dport 9556 -j ACCEPT" 
puts "-A OUTPUT -p tcp -m tcp --dport 9556 -j ACCEPT" 
puts "COMMIT"

    } elseif {$type == "n4cmule"} {
	if {$platform == "WRAP"} {
	} else {
	}
}
