#!/usr/bin/tclsh
#
set filename "topology.tcl"
source $filename

#
set COMMON_CONFIG_1 \
{
client
dev tap
proto udp
remote 134.226.36.138 1194
resolv-retry infinite
nobind
persist-key
persist-tun
tls-client
ca /etc/openvpn/ca.crt
}

set COMMON_CONFIG_2 \
{
#ensure that we are talking to a server
ns-cert-type server
#confirm we are talking to the correct server
tls-auth /etc/openvpn/ta.key 1
# Select a cryptographic cipher.
# If the cipher option is used on the server
# then you must also specify it here.
cipher AES-128-CBC
# Enable compression on the VPN link.
comp-lzo
#fragment large packets
#fragment 1400
# enable user/pass authentication
auth-user-pass /etc/openvpn/creds
verb 5
}

# generate the config
puts "#\n# Configuration generated [clock format [clock seconds]]\n#"
puts $COMMON_CONFIG_1
puts "cert /etc/openvpn/$localhost.crt"
puts "key /etc/openvpn/$localhost.key"
puts $COMMON_CONFIG_2

