#!/usr/bin/tclsh
#
set filename "topology.tcl"
source $filename

# generate the config
if {$type == "n4crouter"} {
    puts "\$ttl 3840"
    puts "$domain.	IN	SOA	$localhost.$domain. $email ("
    puts "			[clock seconds]"
    puts "			10800"
    puts "			3600"
    puts "			604800"
    puts "			38400 )"
    puts "$domain.	IN	NS	$localhost.$domain."
    puts "n4cgateway-1.$domain.	IN	A	$addr(n4cgateway-1)"
    puts "n4cgateway-2.$domain.	IN	A	$addr(n4cgateway-2)"
    puts "n4crouter-1.$domain.	IN	A	$addr(n4crouter-1)"
    puts "n4crouter-2.$domain.	IN	A	$addr(n4crouter-2)"
    puts "n4crouter-3.$domain.	IN	A	$addr(n4crouter-3)"
    puts "n4crouter-4.$domain.	IN	A	$addr(n4crouter-4)"
    puts "n4crouter-5.$domain.	IN	A	$addr(n4crouter-5)"
    puts "n4cmule-1.$domain.	IN	A	$addr(n4cmule-1)"
    puts "n4cmule-2.$domain.	IN	A	$addr(n4cmule-2)"
    puts "n4cmule-3.$domain.	IN	A	$addr(n4cmule-3)"
    puts "n4cmule-4.$domain.    IN      A       $addr(n4cmule-4)"
    puts "n4cmule-5.$domain.    IN      A       $addr(n4cmule-5)"



    puts "$addr(n4cgateway-1).$domain.	IN	PTR	n4cgateway-1.$domain"
    puts "$addr(n4cgateway-2).$domain.	IN	PTR	n4cgateway-2.$domain"
    puts "$addr(n4crouter-1).$domain.	IN	PTR	n4crouter-1.$domain"
    puts "$addr(n4crouter-2).$domain.	IN	PTR	n4crouter-2.$domain"
    puts "$addr(n4crouter-3).$domain.	IN	PTR	n4crouter-3.$domain"
    puts "$addr(n4crouter-4).$domain.	IN	PTR	n4crouter-4.$domain"
    puts "$addr(n4crouter-5).$domain.	IN	PTR	n4crouter-5.$domain"
    puts "$addr(n4cmule-1).$domain.	IN	PTR	n4cmule-1.$domain"
    puts "$addr(n4cmule-2).$domain.	IN	PTR	n4cmule-2.$domain"
    puts "$addr(n4cmule-3).$domain.	IN	PTR	n4cmule-3.$domain"
    puts "$addr(n4cmule-4).$domain.     IN      PTR     n4cmule-4.$domain"
    puts "$addr(n4cmule-5).$domain.     IN      PTR     n4cmule-5.$domain"



    puts "www.village.n4c.eu.	IN	CNAME	$localhost.$domain."
    puts "proxy.village.n4c.eu.	IN	CNAME	$localhost.$domain."
    puts "smtp.village.n4c.eu.	IN	CNAME	$localhost.$domain."
    puts "imap.village.n4c.eu.	IN	CNAME	$localhost.$domain."
    puts "pop.village.n4c.eu.	IN	CNAME	$localhost.$domain."
    puts "ntp.village.n4c.eu.	IN	CNAME	$localhost.$domain."

    puts "n4cgateway-1.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4cgateway-2.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4crouter-1.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4crouter-2.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4crouter-3.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4crouter-4.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4crouter-5.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4mule-1.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4mule-2.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4mule-3.$domain.	IN	MX	5	$localhost.$domain."
    puts "n4mule-4.$domain.     IN      MX      5       $localhost.$domain."
    puts "n4mule-5.$domain.     IN      MX      5       $localhost.$domain."


    puts "$domain.		IN	MX	5	$localhost.$domain."
    puts "$domain.		IN	A	$ip"
    puts "pushed.$domain.		IN	A	$rowip"
    } elseif {$type == "n4cgateway"} {
    puts "\$ttl 3840"
    puts "$domain.      IN      SOA     $localhost.$domain. $email ("
    puts "                      [clock seconds]"
    puts "                      10800"
    puts "                      3600"
    puts "                      604800"
    puts "                      38400 )"
    puts "$domain.      IN      NS      $localhost.$domain."
    puts "n4cgateway-1.$domain. IN      A       $addr(n4cgateway-1)"
    puts "n4cgateway-2.$domain. IN      A       $addr(n4cgateway-2)"
    puts "n4crouter-1.$domain.  IN      A       $addr(n4crouter-1)"
    puts "n4crouter-2.$domain.  IN      A       $addr(n4crouter-2)"
    puts "n4crouter-3.$domain.  IN      A       $addr(n4crouter-3)"
    puts "n4crouter-4.$domain.  IN      A       $addr(n4crouter-4)"
    puts "n4crouter-5.$domain.  IN      A       $addr(n4crouter-5)"
    puts "n4cmule-1.$domain.    IN      A       $addr(n4cmule-1)"
    puts "n4cmule-2.$domain.    IN      A       $addr(n4cmule-2)"
    puts "n4cmule-3.$domain.    IN      A       $addr(n4cmule-3)"
    puts "n4cmule-4.$domain.    IN      A       $addr(n4cmule-4)"
    puts "n4cmule-5.$domain.    IN      A       $addr(n4cmule-5)"



    puts "$addr(n4cgateway-1).$domain.  IN      PTR     n4cgateway-1.$domain"
    puts "$addr(n4cgateway-2).$domain.  IN      PTR     n4cgateway-2.$domain"
    puts "$addr(n4crouter-1).$domain.   IN      PTR     n4crouter-1.$domain"
    puts "$addr(n4crouter-2).$domain.   IN      PTR     n4crouter-2.$domain"
    puts "$addr(n4crouter-3).$domain.   IN      PTR     n4crouter-3.$domain"
    puts "$addr(n4crouter-4).$domain.   IN      PTR     n4crouter-4.$domain"
    puts "$addr(n4crouter-5).$domain.   IN      PTR     n4crouter-5.$domain"
    puts "$addr(n4cmule-1).$domain.     IN      PTR     n4cmule-1.$domain"
    puts "$addr(n4cmule-2).$domain.     IN      PTR     n4cmule-2.$domain"
    puts "$addr(n4cmule-3).$domain.     IN      PTR     n4cmule-3.$domain"
    puts "$addr(n4cmule-4).$domain.     IN      PTR     n4cmule-4.$domain"
    puts "$addr(n4cmule-5).$domain.     IN      PTR     n4cmule-5.$domain"



    puts "www.village.n4c.eu.   IN      CNAME   $localhost.$domain."
    puts "proxy.village.n4c.eu. IN      CNAME   $localhost.$domain."
    puts "smtp.village.n4c.eu.  IN      CNAME   $localhost.$domain."
    puts "imap.village.n4c.eu.  IN      CNAME   $localhost.$domain."
    puts "pop.village.n4c.eu.   IN      CNAME   $localhost.$domain."
    puts "ntp.village.n4c.eu.   IN      CNAME   $localhost.$domain."

    puts "n4cgateway-1.$domain. IN      MX      5       $localhost.$domain."
    puts "n4cgateway-2.$domain. IN      MX      5       $localhost.$domain."
    puts "n4crouter-1.$domain.  IN      MX      5       $localhost.$domain."
    puts "n4crouter-2.$domain.  IN      MX      5       $localhost.$domain."
    puts "n4crouter-3.$domain.  IN      MX      5       $localhost.$domain."
    puts "n4crouter-4.$domain.  IN      MX      5       $localhost.$domain."
    puts "n4crouter-5.$domain.  IN      MX      5       $localhost.$domain."
    puts "n4mule-1.$domain.     IN      MX      5       $localhost.$domain."
    puts "n4mule-2.$domain.     IN      MX      5       $localhost.$domain."
    puts "n4mule-3.$domain.     IN      MX      5       $localhost.$domain."
    puts "n4mule-4.$domain.     IN      MX      5       $localhost.$domain."
    puts "n4mule-5.$domain.     IN      MX      5       $localhost.$domain."


    puts "$domain.              IN      MX      5       $localhost.$domain."
    puts "$domain.              IN      A       $ip"
    puts "pushed.$domain.               IN      A       $ip"
    } elseif {$type == "n4cmule"} {
	if {$id == "WRAP"} {
	} else {
	}
}
