#!/usr/bin/tclsh
#
set filename "topology.tcl"
source $filename

#
set COMMON_CONFIG \
{

magic="1NkIA4jnx2K9w"
n4cap="n4cvillage"
aap_connect () {
    echo 1
    mkdir -p /tmp/cell
    rm -f /tmp/cell/*
    
    iwlist $ifn scan > /tmp/scan.out

    awk 'BEGIN{IGNORECASE=1}/^ *cell [0-9]/{close("/tmp/cell/0"f);f++}{print $0 > "/tmp/cell/0"f}' /tmp/scan.out
        echo "trying to connect 2 " $if $dev $ifn

    for ap in /tmp/cell/0[0-9]* ; do
        echo "`date -R` Trying cell $ap for $n4cap"
        essid=`grep -i essid $ap |awk -F "\"" '{print $2}'` 
        if [ $essid==$n4cap ] ; then                             
	    echo "`date -uR` Found $n4cap in cell $ap with essid $essid" 
#        wifi down $2
            if [ -e /proc/`cat /var/run/$3.pid` ] ; then kill -9 `cat /var/run/$3.pid` ; fi
#            echo 0 > /proc/diag/led/power
            if [ -f /tmp/ap ] ; then rm /tmp/ap ; fi
            if [ -f /tmp/script ] ; then rm /tmp/script ; fi
            sleep 3;
        cat $ap | /usr/sbin/scan2.awk -v ifd=$if -v dev=$dev -v ifn=$ifn
        if [ -e /tmp/ap ] ; then cat /tmp/ap ; fi
   
        if [ -f /tmp/script ] ; then
            . /tmp/script
            echo restarting $2
            wifi up $2
            echo "`date -uR` Connecting to $n4cap via $ifn"
            iw $ifn connect $n4cap
            sleep 15
            ps | grep wlan0
            aap_test
            if [ $ret -eq 0 ] ; then
#                echo 1 > /proc/diag/led/power
                conn=1
                echo `date -uR` test succeeded
                return
            else
                # try to deliver our payload via ping
                echo `date -uR` test failed
                aap_ping
            fi
        fi
        return                                                          
        else                                     
        echo "`date -uR` Could not locate $n4cap"                                  
        fi      
        done
    conn=0
    }
    
aap_maintain() {
    ret=0
    while [ $ret -eq 0 ] ; do
        sleep 15
        echo checking connection
        aap_test
        done
    }
    
aap_test() {
#    wget -O - http://www.gooddomain.com/magic.txt > /tmp/magic
    ping -c 1 10.125.14.1 > /tmp/magic
    ret=$?
    if [ $ret -eq 1 ]; then return ; fi
    if [ `grep -c $magic /tmp/magic` -eq 1 ] ; then
        ret=0
        echo `date -uR` test succeeded - connection up
        return
    fi
    ret=0
    }
    
aap_ping() {
    # placeholder for the ping payload routine
    # eventually craft a ping that can carry a small payload, like GPS coordinates
    # a bit complicated by the fact that busybox ping doesn't have the -p option
    ping -c 1 10.125.14.1
    }
    
aap_payload() {
    echo payload goes here
    # placeholder for whatever we want to do on connection
    # like deliver email, send GPS location coordinates, etc
    }
    
    
while [ 1 ] ; do
    # do this every time in case our user hotplugged an if
    wif=`uci show wireless | grep "mode=sta" | cut -f2 -d.`
    for if in $wif ; do
        echo "Using $if"
            dev=`uci show wireless.$if.device | cut -f2 -d=`
                net=`uci show wireless.$if.network | cut -f2 -d=`
                ifn=`uci -P /var/state show wireless.$if.ifname | cut -f2 -d=`
                echo "trying to connect" $if $dev $ifn
        aap_connect $if $dev $ifn
        if [ $conn -eq 1 ] ; then
            aap_payload
            aap_maintain
            fi
        sleep 15
        done
    done
}
# generate the config
puts "#!/bin/ash"
puts $COMMON_CONFIG
