#!/usr/bin/tclsh
set filename "topology.tcl"
source $filename

#
#
# generate the config
puts "#!/bin/bash"
puts "uci add dhcp dnsmasq"
puts "uci set dhcp.@dnsmasq\[0\]=dnsmasq"
puts "uci set dhcp.@dnsmasq\[0\].domainneeded=1"
puts "uci set dhcp.@dnsmasq\[0\].boguspriv=1"
puts "uci set dhcp.@dnsmasq\[0\].filterwin2k=0"
puts "uci set dhcp.@dnsmasq\[0\].localise_queries=1"
puts "uci set dhcp.@dnsmasq\[0\].local=/lan/"
puts "uci set dhcp.@dnsmasq\[0\].domain=lan"
puts "uci set dhcp.@dnsmasq\[0\].expandhosts=1"
puts "uci set dhcp.@dnsmasq\[0\].nonegcache=0"
puts "uci set dhcp.@dnsmasq\[0\].authoritative=1"
puts "uci set dhcp.@dnsmasq\[0\].readethers=1"
puts "uci set dhcp.@dnsmasq\[0\].leasefile=/tmp/dhcp.leases"
puts "uci set dhcp.@dnsmasq\[0\].resolvfile=/tmp/resolv.conf.auto"
puts "uci set dhcp.lan=dhcp"
puts "uci set dhcp.lan.interface=lan"
puts "uci set dhcp.lan.start=100"
puts "uci set dhcp.lan.limit=150"
puts "uci set dhcp.lan.leasetime=12h"
puts "uci set dhcp.wan=dhcp"
puts "uci set dhcp.wan.interface=wan"
puts "uci set dhcp.wan.ignore=1"
puts "uci commit dhcp"
puts "uci add dropbear dropbear"
puts "uci set dropbear.@dropbear\[0\]=dropbear"
puts "uci set dropbear.@dropbear\[0\].PasswordAuth=off"
puts "uci set dropbear.@dropbear\[0\].Port=22"
puts "uci commit dropbear"
puts "uci add firewall defaults"
puts "uci add firewall zone"
puts "uci add firewall forwarding"
puts "uci add firewall rule"
puts "uci add firewall include"
puts "uci set firewall.@defaults\[0\]=defaults"
puts "uci set firewall.@defaults\[0\].syn_flood=1"
puts "uci set firewall.@defaults\[0\].input=ACCEPT"
puts "uci set firewall.@defaults\[0\].output=ACCEPT"
puts "uci set firewall.@defaults\[0\].forward=REJECT"
puts "uci set firewall.@zone\[0\]=zone"
puts "uci set firewall.@zone\[0\].name=lan"
puts "uci set firewall.@zone\[0\].input=ACCEPT"
puts "uci set firewall.@zone\[0\].output=ACCEPT"
puts "uci set firewall.@zone\[0\].forward=REJECT"
puts "uci set firewall.@zone\[1\]=zone"
puts "uci set firewall.@zone\[1\].name=wan"
puts "uci set firewall.@zone\[1\].input=ACCEPT"
puts "uci set firewall.@zone\[1\].output=ACCEPT"
puts "uci set firewall.@zone\[1\].forward=REJECT"
puts "uci set firewall.@zone\[1\].masq=1"
puts "uci set firewall.@zone\[1\].mtu_fix=1"
puts "uci set firewall.@forwarding\[0\]=forwarding"
puts "uci set firewall.@forwarding\[0\].src=lan"
puts "uci set firewall.@forwarding\[0\].dest=wan"
puts "uci set firewall.@rule\[0\]=rule"
puts "uci set firewall.@rule\[0\].src=wan"
puts "uci set firewall.@rule\[0\].proto=udp"
puts "uci set firewall.@rule\[0\].dest_port=68"
puts "uci set firewall.@rule\[0\].target=ACCEPT"
puts "uci set firewall.@rule\[1\]=rule"
puts "uci set firewall.@rule\[1\].src=wan"
puts "uci set firewall.@rule\[1\].proto=icmp"
puts "uci set firewall.@rule\[1\].icmp_type=echo-request"
puts "uci set firewall.@rule\[1\].target=ACCEPT"
puts "uci set firewall.@include\[0\]=include"
puts "uci set firewall.@include\[0\].path=/etc/firewall.user"
puts "uci commit firewall"
puts "uci add fstab mount"
puts "uci add fstab swap"
puts "uci set fstab.automount=global"
puts "uci set fstab.automount.from_fstab=1"
puts "uci set fstab.automount.anon_mount=1"
puts "uci set fstab.autoswap=global"
puts "uci set fstab.autoswap.from_fstab=1"
puts "uci set fstab.autoswap.anon_swap=0"
puts "uci set fstab.@mount\[0\]=mount"
puts "uci set fstab.@mount\[0\].target=/data"
puts "uci set fstab.@mount\[0\].device=/dev/sda3"
puts "uci set fstab.@mount\[0\].fstype=ext4"
puts "uci set fstab.@mount\[0\].options=rw,sync"
puts "uci set fstab.@mount\[0\].enabled=1"
puts "uci set fstab.@mount\[0\].enabled_fsck=1"
puts "uci set fstab.@swap\[0\]=swap"
puts "uci set fstab.@swap\[0\].device=/dev/sda2"
puts "uci set fstab.@swap\[0\].enabled=0"
puts "uci commit fstab"
puts "uci add httpd httpd"
puts "uci set httpd.@httpd\[0\]=httpd"
puts "uci set httpd.@httpd\[0\].port=80"
puts "uci set httpd.@httpd\[0\].home=/www"
puts "uci commit httpd"
puts "uci set network.loopback=interface"
puts "uci set network.loopback.ifname=lo"
puts "uci set network.loopback.proto=static"
puts "uci set network.loopback.ipaddr=127.0.0.1"
puts "uci set network.loopback.netmask=255.0.0.0"
puts "uci set network.lan=interface"
puts "uci set network.lan.ifname=eth0"
puts "uci set network.lan.type=bridge"
puts "uci set network.lan.proto=static"
puts "uci set network.lan.netmask=255.255.255.0"
puts "uci set network.lan.ipaddr=10.125.[expr "$ipoctet3" + "2" ].$ipoctet4"
puts "uci set network.wan=interface"
puts "uci set network.wan.ifname=wlan0"
puts "uci set network.wan.proto=dhcp"
puts "uci commit network"
puts "uci add ntpd ntpd"
puts "uci set ntpd.@ntpd\[0\]=ntpd"
puts "uci set ntpd.@ntpd\[0\].TimeServers=$timesvr1 $timesvr2"
puts "uci set ntpd.@ntpd\[0\].ClientAccessFrom=wan"
puts "uci commit ntpd"
puts "uci add system system"
puts "uci set system.@system\[0\]=system"
puts "uci set system.@system\[0\].hostname=$localhost"
puts "uci set system.@system\[0\].timezone=UTC"
puts "uci commit system"
puts "uci add wirelesss wifi-iface"
puts "uci set wireless.radio0=wifi-device"
puts "uci set wireless.radio0.type=mac80211"
puts "uci set wireless.radio0.channel=1"
puts "uci set wireless.radio0.macaddr=$mac($localhost)"
puts "uci set wireless.radio0.hwmode=11g"
puts "uci set wireless.radio0.disabled=0"
puts "uci set wireless.@wifi-iface\[0\]=wifi-iface"
puts "uci set wireless.@wifi-iface\[0\].device=radio0"
puts "uci set wireless.@wifi-iface\[0\].network=wan"
puts "uci set wireless.@wifi-iface\[0\].mode=sta"
puts "uci set wireless.@wifi-iface\[0\].encryption=none"
puts "uci commit wireless"
