#!/usr/bin/tclsh
#
# Simple tcl script to generate a static topology of dtn links and
# routes for a network.
set addr(basil.dsg.cs.tcd.ie)   192.168.1.102
set addr(n4cgateway-1)          10.125.14.10
set addr(n4cgateway-2)          10.125.14.11
set addr(n4crouter-1)           10.125.14.12
set addr(n4crouter-2)           10.125.14.13
set addr(n4crouter-3)           10.125.14.14
set addr(n4crouter-4)           10.125.14.15
set addr(n4crouter-5)           10.125.14.16
set addr(n4cmule-1)             10.125.14.17
set addr(n4cmule-2)             10.125.14.18
set addr(n4cmule-3)             10.125.14.19
set addr(n4cmule-4)             10.125.14.20
set addr(n4cmule-5)             10.125.14.21



set localhost [lindex [split [info hostname] .] 0]
set ip $addr([lindex [split [info hostname] .] 0])
set type [lindex [split [info hostname] -] 0]
set subnet 10.125.15.0
set localdom village.n4c.eu
set domain [lindex $argv 1]
set site [lindex $argv 0]
set addr($site.$domain)         $ip
set net [lindex [split $ip .] 2]
set no [lindex [split $ip .] 3]

set email alex\\.mcmahon.cs.tcd.ie
#
# Common config for all nodes
#
# generate the config
if {$type == "n4crouter"} {
    puts "\$ttl 3840"
    puts "$domain.	IN	SOA	$localhost.$localdom. $email ("
    puts "			[clock seconds]"
    puts "			10800"
    puts "			3600"
    puts "			604800"
    puts "			38400 )"
    puts "$domain.	IN	NS	$localhost.$localdom."
    puts "$site.$domain.	IN	A	10.125.[expr "$net" + "1" ].$no"

    puts "10.125.[expr "$net" + "1" ].$no.$domain.	IN	PTR	$site.$domain"

    puts "$domain.		IN	MX	5	$localhost.$localdom."
    puts "$domain.		IN	A	$subnet"
    } elseif {$type == "n4cgateway"} {
    } elseif {$type == "n4cmule"} {
	if {$id == "WRAP"} {
	} else {
	}
}
